<?php

class DHWC_Layout_Frontend {
	public function __construct(){
		
		add_filter( 'template_include', array( &$this, 'template_loader' ) ,1000);
		
		add_action('template_redirect', array($this,'register_assets'),1);
		
		add_action( 'wp_enqueue_scripts', array($this,'enqueue_assets' ));
		
		add_action( 'wp_head', array($this,'shortcodes_custom_css'));
		
	}
	
	public static function dhwc_ajax_elment_product_item(){
		return '.dhvc-woo-list-items > div';
	}
	
	public static function dhwc_ajax_elment_product_wrapper(){
		return '.dhvc-woo';
	}
	
	public static function dhwc_ajax_elment_product_list(){
		return '.dhvc-woo-list-items';
	}
	
	public function register_assets()
	{

	    if(apply_filters('dhwc_layout_register_isotope_js', true)){
		  wp_register_script('isotope', DHVC_WOO_URL.'/assets/js/isotope.pkgd.min.js',array('jquery'),DHVC_WOO_VERSION,true);
	    }
	    
	    if(apply_filters('dhwc_layout_register_owlcarousel_js', true)){
    		wp_register_script('dhwc-layout-owlcarousel', DHVC_WOO_URL.'/assets/js/owl.carousel/owl.carousel.min.js',array('jquery'),DHVC_WOO_VERSION,true);
    		wp_register_style('dhwc-layout-owlcarousel', DHVC_WOO_URL.'/assets/js/owl.carousel/assets/owl.carousel.css');
	    }
	    
		wp_register_script('dhwc-layout-modal', DHVC_WOO_URL.'/assets/js/dhmodal.js',array('jquery'),DHVC_WOO_VERSION,true);
		wp_register_style('dhwc-layout-modal', DHVC_WOO_URL.'/assets/css/dhmodal.css');
		
	}
	
	public function shortcodes_custom_css(){
		global $dhwc_layout_custom_content_template;
		if(empty($dhwc_layout_custom_content_template))
			return;
		
		$post_custom_css = get_post_meta( $dhwc_layout_custom_content_template->ID, '_wpb_post_custom_css', true );
		$output = '';
		if ( ! empty( $post_custom_css ) ) {
			$post_custom_css = strip_tags( $post_custom_css );
			$output .= '<style id="dhwc_layout_post_css" type="text/css">';
			$output .= $post_custom_css;
			$output .= '</style>';
		}
		$shortcodes_custom_css = get_post_meta( $dhwc_layout_custom_content_template->ID, '_wpb_shortcodes_custom_css', true );
		if ( ! empty( $shortcodes_custom_css ) ) {
			$shortcodes_custom_css = strip_tags( $shortcodes_custom_css );
			$output .= '<style id="dhwc_layout_shortcode_css" type="text/css">';
			$output .= $shortcodes_custom_css;
			$output .= '</style>';
		}
		echo $output;
	}
	
	public function template_loader( $template ){
		global $post,$dhwc_layout_custom_content_template;
		$content_page_template = false;
		
		if(is_shop() && 'yes'===get_option('dhvc_woo_product_archives')){
			
		    $content_page_template = get_post(wc_get_page_id('shop'));
			
		}elseif (is_product_taxonomy()){
		    
			$term = get_queried_object();
			$taxonomy = $term->taxonomy;
			
			if($taxonomy_setting_field_id = dhwc_layout_get_taxonomy_setting_field_id($taxonomy)){
    			
			    $content_page_template_id = (int) get_term_meta($term->term_id, $taxonomy_setting_field_id,true);
    			
    			if(!empty($content_page_template_id)){
    				$content_page_template = get_post($content_page_template_id);
    			}
			}
			
		}
		
		if(false!==$content_page_template){
			$dhwc_layout_custom_content_template = $content_page_template;
			
			if(class_exists('Ultimate_VC_Addons')){
				$backup_post = $post;
				$post  = $content_page_template;
				$Ultimate_VC_Addons = new Ultimate_VC_Addons;
				$Ultimate_VC_Addons->aio_front_scripts();
				$post = $backup_post;
			}
			
			$find = array();
			$file = 'archive-product.php';
			$find[] = 'dhvc-woocommerce/'.$file;
			$template       = locate_template( $find );
			
			if ( ! $template || WC_TEMPLATE_DEBUG_MODE){
				$template = DHVC_WOO_DIR . '/templates/' . $file;
			}
		}
		
		return $template;
	}
	
	public function enqueue_assets(){
		$this->enqueue_css();
		$this->enqueue_js();
	}
	
	public function enqueue_css(){
		wp_register_style('dhwc-layout', DHVC_WOO_URL.'/assets/css/style.css');
		wp_enqueue_style('dhwc-layout');
	}
	
	public function enqueue_js(){
		wp_register_script('dhwc-layout',DHVC_WOO_URL.'/assets/js/script.js',array('jquery'),DHVC_WOO_VERSION,true);
		$dhwc_layout_params = array(
			'ajax_url'=>admin_url( 'admin-ajax.php', 'relative' ),
		);
		wp_localize_script('dhwc-layout', 'dhwc_layout_params', $dhwc_layout_params);
		
		wp_enqueue_script('dhwc-layout');
	}
}
new DHWC_Layout_Frontend();