<?php

class DHWC_Layout_Shortcode {
	
	private $_shortcode_id = 0;
	
	public function __construct(){
		add_shortcode('dhvc_woo_products', array($this,'shortcode_output'));
	}
	
	public function shortcode_output($atts){
		$atts = shortcode_atts( array (
			'id'=>'',
			'heading' => '',
			'heading_color'=>'#47A3DA',
			'heading_font_size'=>'20px',
			'query_options' => '',
			'query_type'=>'build',
			'products'=>'',
			'exclude_products'=>'',
			'category' => '',
			'exclude_category'=>'',
			'brand'=>'',
			'exclude_brand'=>'',
			'tag'=>'',
			'exclude_tag'=>'',
			'attribute'=>'',
			'posts_per_page' => '9',
			'post_per_row' => '4',
			'show' => '',
		    'stock_status' => '',
			'orderby' => 'date',
			'order' => 'ASC',
			'hide_free' => '',
			'show_hidden' => '',
			'style_options' => '',
			'display' => 'grid',
			'use_default_style_of_theme'=>'',
			'hide_result_count'=>'',
			'hide_ordering_list'=>'',
			'hide_grid_pagination' => '',
			'show_masonry_filter' => '',
			'masonry_filters_background' => '#ffffff',
			'masonry_filters_selected_background' => '#47A3DA',
			'masonry_filters_color' => '#666666',
			'masonry_filters_selected_color' => '#ffffff',
			'masonry_filters_border_color' => '#ffffff',
			'masonry_filters_selected_border_color' => '#47A3DA',
			'masonry_gutter' => 0,
			'hide_carousel_arrows' => '',
			'carousel_autoplay'    => '',
			'carousel_autoplay_timeout'=>'2000',
			'show_carousel_pagination' => '',
			'carousel_arrow_size' => '',
			'carousel_pagination_background' => '#869791',
			'carousel_pagination_active_background' => '#47A3DA',
			'carousel_pagination_size' => '',
			'item_border_style' => 'solid',
			'item_border_color' => '#e1e1e1',
			'item_border_width' => '',
			'hide_thumbnail' => '',
			'hover_thumbnail'=>'',
			'thumbnail_background_color' => '#ffffff',
			'thumbnail_border_style' => 'solid',
			'thumbnail_border_color' => '#e1e1e1',
			'thumbnail_border_width' => '',
			'thumbnail_border_radius' => '',
			'thumbnail_padding' => '',
			'box_thumbnail_width' => '',
			'thumbnail_margin' => '',
			'thumbnail_width' => '',
			'thumbnail_height' => '',
			'hide_title' => '',
			'title_align' => 'center',
			'title_color' => '#47A3DA',
			'title_hover_color' => '#98D2F7',
			'title_font_size' => '',
			'title_padding' => '',
			'title_margin' => '',
			'show_excerpt' => '',
			'excerpt_length' => '15',
			'excerpt_align' => '',
			'excerpt_color' => '',
			'excerpt_font_size' => '',
			'excerpt_padding' => '',
			'excerpt_margin' => '',
			'hide_price' => '',
			'price_color' => '',
			'no_discount_price_color' => '',
			'price_font_size' => '',
			'no_discount_price_font_size' => '',
			'price_padding' => '',
			'price_margin' => '',
			'hide_addtocart' => '',
			'addtocart_text' => 'Add to cart',
			'addtocart_color' => '',
			'addtocart_font_size' => '',
			'addtocart_padding' => '',
			'addtocart_margin' => '',
			'add_cart_price_style'=>'',
			'show_rating' => '',
			'hide_sale_flash'=>'',
			'show_out_of_stock_flash'	=> '',
			'out_of_stock_text'	=> '',
			'show_quickview'=>'',
			'el_class' => '',
			'css'=>'',
		), $atts );
		
		$this->_shortcode_id++;
		$id = 'dhwc_layout_'.$this->_shortcode_id;

		$el_class = $atts['el_class'];
		$el_class .= $this->_get_vc_custom_css_class($atts['css']);
		
		$query = null;
		$paginated = false;
		$is_shortcode = true;
		
		//backwards compatibility
		if('2'===$atts['query_type']){
			$atts['query_type'] = 'main';
		}elseif ('1'===$atts['query_type']){
			$atts['query_type'] = 'build';
		}
		
		$build_query = $this->_build_query($atts);
		
		if('main' === $atts['query_type'] && ( is_shop() ||  is_tax( get_object_taxonomies( 'product' ) ))){
			$query = $GLOBALS['wp_query'];
			$is_shortcode = false;
		}elseif('masonry'!== $atts['display']){
			$query = new WP_Query($build_query);
		}
		
		$style_template = $atts['display'];
		
		ob_start();
		
		//Inline style
		echo dhwc_layout_parse_shortcode_inline_style($id, $atts);
		
		//Heading
		if(!empty($atts['heading'])){
			dhwc_layout_get_template("parts/heading.php",array('heading'=>$atts['heading']));
		}
		
		if('masonry' === $style_template){
			dhwc_layout_get_template("styles/{$style_template}.php",array(
				'query'			=> $query,
				'atts'			=> $atts,
				'query_args' 	=> $build_query
			));
		}else{
			$paginated = ! $query->get( 'no_found_rows' );
			// Setup the loop.
			wc_setup_loop(
				array(
					'columns'      => (int) $atts['post_per_row'],
					'name'         => 'dhwc-layout-'.$atts['query_type'],
					'is_shortcode' => $is_shortcode,
					'is_search'    => false,
					'is_paginated' => $paginated,
					'total'        => $paginated ? (int) $query->found_posts : count( $query->posts ),
					'total_pages'  => $paginated ? (int) $query->max_num_pages : 1,
					'per_page'     => (int) $query->get( 'posts_per_page' ),
					'current_page' => $paginated ? (int) max( 1, $query->get( 'paged', 1 ) ) : 1,
				)
			);
			
			if($query->have_posts()):
				
				//Toolbar
				dhwc_layout_get_template('parts/toolbar.php',array('atts'=>$atts));
				
				if('yes'===$atts['use_default_style_of_theme']){
					$style_template = 'default-theme';
				}
				
				echo $this->_product_loop($style_template, $query, $atts, $build_query);
				
				wp_reset_postdata();
				wc_reset_loop();
				
				// Remove ordering query arguments which may have been added by get_catalog_ordering_args.
				WC()->query->remove_ordering_args();
			else:
				do_action('woocommerce_no_products_found');
			endif;
		}
		
		return '<div id="'.$id.'" class="woocommerce dhvc-woo dhvc-woo-' . $style_template . ' ' . $el_class . '">'.ob_get_clean().'</div>';
	}
	
	protected function _product_loop($style_template, $query, $atts, $build_query){
		ob_start();
		
		do_action("dhwc_layout_product_loop_style_{$style_template}_before", $query, $atts, $build_query);
		
		dhwc_layout_get_template("styles/{$style_template}.php",array(
			'query'			=> $query,
			'atts'			=> $atts,
			'query_args' 	=> $build_query
		));
		
		do_action("dhwc_layout_product_loop_style_{$style_template}_after", $query, $atts, $build_query);
		
		return apply_filters('dhwc_layout_product_loop', ob_get_clean(), $atts);
	}
	
	private function _build_query($atts){
		global $product;
		
		extract($atts);
		

		if( is_front_page() ) {
			$paged = ( get_query_var( 'page' ) ) ? get_query_var( 'page' ) : 1;
		} else {
			$paged = ( get_query_var( 'paged' ) ) ? get_query_var( 'paged' ) : 1 ;
		}
			
		$paged = empty( $_GET['product-page']) ? $paged : $_GET['product-page']; // WPCS: input var ok, CSRF ok.
		
		$query_args = array(
			'paged'    				=> $paged,
			'posts_per_page'  		=> (int) $posts_per_page,
			'post_status'    		=> 'publish',
			'post_type'    			=> 'product',
			'order'           		=> $order,
			'no_found_rows'			=> true,
			'ignore_sticky_posts'	=> true,
		);
		
		if ('upsell'=== $query_type && is_product()){
			$upsell_ids = $product->get_upsell_ids();
			if(!empty($upsell_ids)){
				$query_args['post__in']= $upsell_ids;
				$query_args['post__not_in'] = array($product->get_id());
			}
			
		}elseif ('crosssell'=== $query_type && is_product()){
				
			$cross_sell_ids = $product->get_cross_sell_ids();
				
			if(!empty($cross_sell_ids)){
				$query_args['post__in']= $cross_sell_ids;
				$query_args['post__not_in'] = array($product->get_id());
			}
				
		}elseif ('related'=== $query_type && is_product()){
				
			$related_ids = wc_get_related_products( $product->get_id(), $atts['posts_per_page'] );
		
			if(!empty($related_ids)){
				$query_args['post__in']= $related_ids;
				$query_args['post__not_in'] = array($product->get_id());
			}
		
		}else{
			if( in_array($display, array('list','grid','flex')) && empty($hide_grid_pagination)){
				$query_args['no_found_rows'] = false;
			}
			
			$product_visibility_term_ids = wc_get_product_visibility_term_ids();
				
			//include products
			if(!empty($products)){
				$query_args ['post__in'] = explode(',',$products);
			}
			
			//exclude products
			if(!empty($exclude_products)){
				$query_args ['post__not_in'] = explode(',',$exclude_products);
			}
			
			$query_args['tax_query'] = array(
				'relation' => 'AND',
			);
				
			//In Categories
			if('masonry'!==$display && !empty($category)){
				$query_args['tax_query'][] = array(
					'taxonomy'  => 'product_cat',
					'field'    	=> 'id',
					'terms'    	=> explode(',',$category),
					'operator'  => 'IN'
				);
			}
					
			// Not IN Categories
			if(!empty($exclude_category)){
				$query_args['tax_query'][] = array(
					'taxonomy'  => 'product_cat',
					'field'    	=> 'id',
					'terms'    	=> explode(',',$exclude_category),
					'operator'  => 'NOT IN'
				);
			}
		
			//In Brand
			if(!empty($brand)){
				$query_args['tax_query'][] = array(
					'taxonomy'  => 'product_brand',
					'field'    	=> 'id',
					'terms'    	=> explode(',',$brand),
					'operator'  => 'IN'
				);
			}
			//Not in Brand
			if(!empty($exclude_brand)){
				$query_args['tax_query'][] = array(
					'taxonomy'  => 'product_brand',
					'field'    	=> 'id',
					'terms'    	=> explode(',',$exclude_brand),
					'operator'  => 'NOT IN'
				);
			}
			//In tag
			if(!empty($tag)){
				$query_args['tax_query'][] = array(
					'taxonomy'  => 'product_tag',
					'field'    	=> 'id',
					'terms'    	=> explode(',',$tag),
					'operator'  => 'IN'
				);
			}
			//Not in tag
			if(!empty($exclude_tag)){
				$query_args['tax_query'][] = array(
					'taxonomy'  => 'product_tag',
					'field'    	=> 'id',
					'terms'    	=> explode(',',$exclude_tag),
					'operator'  => 'NOT IN'
				);
			}
							
			//In attributes
			if(!empty($attribute)){
				$attribute_arr = explode(',', $attribute);
				$t = array();
				foreach ($attribute_arr as $attr){
					$attr_arr = explode('|', $attr);
					$t[$attr_arr[0]][] = $attr_arr[1];
						
				}
				if(!empty($t)){
					foreach ($t as $key=>$tarr){
						$query_args['tax_query'][] = array(
							'taxonomy'  => $key,
							'field'    	=> 'slug',
							'terms'    	=> $tarr,
							'operator'  => 'IN'
						);
					}
				}
			}
		}
		
		//Meta query
		$query_args['meta_query'] = array();
		
		if('yes'===$show_hidden){
			$query_args['tax_query'][] = array(
				'taxonomy' => 'product_visibility',
				'field'    => 'term_taxonomy_id',
				'terms'    => is_search() ? $product_visibility_term_ids['exclude-from-search'] : $product_visibility_term_ids['exclude-from-catalog'],
				'operator' => 'NOT IN',
			);
			$query_args['post_parent'] = 0;
		}
		
		//Hide free
		if('yes'===$hide_free){
			$query_args['meta_query'][] = array(
				'key'     => '_price',
				'value'   => 0,
				'compare' => '>',
				'type'    => 'DECIMAL',
			);
		}
		
		//Hide out of stock
		if ( 'yes' === get_option( 'woocommerce_hide_out_of_stock_items' ) ) {
			$query_args['tax_query'][] = array(
				array(
					'taxonomy' => 'product_visibility',
					'field'    => 'term_taxonomy_id',
					'terms'    => $product_visibility_term_ids['outofstock'],
					'operator' => 'NOT IN',
				),
			); // WPCS: slow query ok.
		}
		
		//Stock staus
		if(!empty($stock_status)){
		    $query_args['meta_query'][] = array(
		        'key'     => '_stock_status',
		        'value'   => $stock_status,
		    );
		}
		
		switch ($show){
			case 'featured':
				$query_args['tax_query'][] = array(
					'taxonomy' => 'product_visibility',
					'field'    => 'term_taxonomy_id',
					'terms'    => $product_visibility_term_ids['featured'],
				);
				break;
			case 'onsale':
				$product_ids_on_sale    = wc_get_product_ids_on_sale();
				$product_ids_on_sale[]  = 0;
				$query_args['post__in'] = $product_ids_on_sale;
				break;
		}
			
		//Ordering option
		if(isset($_GET['orderby']) && !empty($_GET['orderby'])){
			$orderby_value = wc_clean($_GET['orderby']);
			// Get order + orderby args from string
			$orderby_value = explode( '-', $orderby_value );
			$orderby       = esc_attr( $orderby_value[0] );
			$order         = ! empty( $orderby_value[1] ) ? $orderby_value[1] : $order;
		}
			
		$query_args['order'] = strtoupper($order);
			
		switch ( $orderby ) {
			case 'title':
				$query_args['orderby']  = 'title';
				break;
			case 'modified':
				$query_args['orderby']  = 'modified';
				break;
			case 'comment_count':
				$query_args['orderby']  = 'comment_count';
				break;
			case 'popularity' :
				$query_args['meta_key'] = 'total_sales';
				// Sorting handled later though a hook
				add_filter( 'posts_clauses', array( WC()->query, 'order_by_popularity_post_clauses' ) );
				break;
			case 'rating' :
				$query_args['meta_key'] = '_wc_average_rating'; // @codingStandardsIgnoreLine
				$query_args['orderby']  = array(
					'meta_value_num' => 'DESC',
					'ID'             => 'ASC',
				);
				break;
			case 'date' :
				$query_args['orderby']  = 'date ID';
				break;
			case 'rand' :
				$query_args['orderby']  = 'rand';
				break;
			case 'sales' :
				$query_args['meta_key'] = 'total_sales';
				$query_args['orderby']  = 'meta_value_num';
				break;
			case 'price':
				$query_args['meta_key'] = '_price';
				$query_args['orderby'] = 'meta_value_num ID';
				break;
			case 'price-desc':
				$query_args['meta_key'] = '_price';
				$query_args['orderby'] = 'meta_value_num ID';
				break;
			default :
				$ordering_args = WC()->query->get_catalog_ordering_args($orderby, $order);
				$query_args['orderby'] = $ordering_args['orderby'];
				$query_args['order'] = $ordering_args['order'];
				break;
		}
		
		return  apply_filters('dhvc_woo_query_args', $query_args, $atts);
	}
	
	protected function _get_vc_custom_css_class($param_value, $prefix = ' ' ){
		$css_class = preg_match( '/\s*\.([^\{]+)\s*\{\s*([^\}]+)\s*\}\s*/', $param_value ) ? $prefix . preg_replace( '/\s*\.([^\{]+)\s*\{\s*([^\}]+)\s*\}\s*/', '$1', $param_value ) : '';
		return $css_class;
	}
}
new DHWC_Layout_Shortcode();