<?php
function dhwc_layout_parse_shortcode_custom_css($content){
	$css = '';
	preg_match_all( '/' . get_shortcode_regex() . '/', $content, $shortcodes );
	foreach ( $shortcodes[2] as $index => $tag ) {
		if('dhvc_woo_products' !== $tag){
			continue;
		}
		$atts = shortcode_parse_atts( trim( $shortcodes[3][ $index ] ) );
		$id = isset($atts['id']) ? $atts['id'] : _dhwc_layout_get_rand_id();
		$css .= dhwc_layout_parse_shortcode_inline_style( $id , $atts );
	}
	
	foreach ( $shortcodes[5] as $shortcode_content ) {
		$css .= dhwc_layout_parse_shortcode_custom_css( $shortcode_content );
	}
	return $css;
}

function dhwc_layout_show_ajax_toolbar(){
	return apply_filters('dhwc_layout_show_ajax_toolbar', true);
}

function dhwc_layout_parse_shortcode_inline_style( $shortcode_id, $atts ){
	extract($atts);
	$id = $shortcode_id;
	$inline_style='
	#'.$id.' .dhvc-woo-heading {
		' . dhwc_layout_print_css('color',$heading_color ) . '
		' . dhwc_layout_print_css('font-size',$heading_font_size) . '
	}
	#'.$id.' .dhvc-woo-item {
		'.dhwc_layout_print_css('border-width',$item_border_width).'
		'.dhwc_layout_print_css('border-style',$item_border_style).'
		'.dhwc_layout_print_css('border-color',$item_border_color).'
	}
	#'.$id.' .dhvc-woo-images{
		' . dhwc_layout_print_css('background-color',$thumbnail_background_color) . '
		' . dhwc_layout_print_css('border-style',$thumbnail_border_style) . '
		' . dhwc_layout_print_css('border-width',$thumbnail_border_width) . '
		' . dhwc_layout_print_css('border-color',$thumbnail_border_color) . '
		' . dhwc_layout_print_css('border-radius',$thumbnail_border_radius) . '
		' . dhwc_layout_print_css('padding',$thumbnail_padding) . '
		' . dhwc_layout_print_css('margin',$thumbnail_margin) . '
	}
	#'.$id.' .dhvc-woo-title{
		' . dhwc_layout_print_css('text-align',$title_align ) . '
		'.dhwc_layout_print_css('padding',$title_padding ).'
		'.dhwc_layout_print_css('margin',$title_margin ).'
	}
	#'.$id.' .dhvc-woo-title a{
		' . dhwc_layout_print_css('color',$title_color ) . '
		' . dhwc_layout_print_css('font-size',$title_font_size ) . '
		
	}
	#'.$id.' .dhvc-woo-title a:hover{
		' . dhwc_layout_print_css('color',$title_hover_color ) . '
	}
	#'.$id.' .dhvc-woo-excerpt{
		'.dhwc_layout_print_css('text-align',$excerpt_align ) . '
		'.dhwc_layout_print_css('color',$excerpt_color ).'
		'.dhwc_layout_print_css('font-size',$excerpt_font_size ).'
		'.dhwc_layout_print_css('padding',$excerpt_padding ).'
		'.dhwc_layout_print_css('margin',$excerpt_margin ).'
	}
	#'.$id.' .dhvc-woo-price{
		'.dhwc_layout_print_css('padding',$price_padding ).'
		'.dhwc_layout_print_css('margin',$price_margin ).'
	}
	#'.$id.' .dhvc-woo-price .amount,
	#'.$id.' .dhvc-woo-price ins .amount{
		'.dhwc_layout_print_css('color',$price_color ).'
		'.dhwc_layout_print_css('font-size',$price_font_size ).'
		
	}
	#'.$id.' .dhvc-woo-price del .amount{
		'.dhwc_layout_print_css('color',$no_discount_price_color ).'
		'.dhwc_layout_print_css('font-size',$no_discount_price_font_size ).'
	}
	#'.$id.' .dhvc-woo-addtocart a{
		'.dhwc_layout_print_css('padding',$addtocart_padding ).'
		'.dhwc_layout_print_css('margin',$addtocart_margin ).'
	}
	#'.$id.' .dhvc-woo-filters a {
		'.dhwc_layout_print_css('border-color',$masonry_filters_border_color ).';
	    '.dhwc_layout_print_css('background-color',$masonry_filters_background ).';
	    '.dhwc_layout_print_css('color',$masonry_filters_color ).';
	
	}
	#'.$id.' .dhvc-woo-filters a.selected,
	#'.$id.' .dhvc-woo-filters a:hover{
		'.dhwc_layout_print_css('background-color',$masonry_filters_selected_background ).';
		'.dhwc_layout_print_css('color',$masonry_filters_selected_color ).';
		'.dhwc_layout_print_css('border-color',$masonry_filters_selected_border_color ).';
	}
	#'.$id.' .owl-theme .owl-controls .owl-nav .owl-next::before, 
	#'.$id.' .owl-theme .owl-controls .owl-nav .owl-prev::before{
		'.dhwc_layout_print_css('width',$carousel_arrow_size).'
		'.dhwc_layout_print_css('height',$carousel_arrow_size).'
	}
	#'.$id.' .owl-theme .owl-dots .owl-dot span{
		'.dhwc_layout_print_css('width',$carousel_pagination_size ).'
		'.dhwc_layout_print_css('height',$carousel_pagination_size ).'
		'.dhwc_layout_print_css('background',$carousel_pagination_background ).'
	}
	
	#'.$id.' .owl-theme .owl-dots .owl-dot.active span,
	#'.$id.' .owl-theme .owl-dots .owl-dot:hover span{
		'.dhwc_layout_print_css('background',$carousel_pagination_active_background ).'
	}
	';
	$inline_sceen = apply_filters('dhwc_layout_inline_style_screen', '601px');
	$inline_style = dhwc_layout_css_minify($inline_style);
	return '<style scoped>'.$inline_style.'</style>';
}

function dhwc_layout_print_css($rule,$value=''){
	$value = trim($value);
	if(''===(string)$value || 'none'===$value)	
		return ;
	return "{$rule}: {$value};";
}


function dhwc_layout_pagination($query,$atts){
	ob_start();
	dhwc_layout_get_template('parts/pagination.php',array('query'=>$query,'atts'=>$atts));
	echo apply_filters('dhwc_layout_pagination', ob_get_clean(), $query, $atts);
}


function dhwc_layout_get_taxonomy_setting_field_id($taxonomy){
	$setting_fields = array(
		'product_cat'	=> 'dhvc_woo_category_page_id',
		'product_tag'	=> 'dhvc_woo_tag_page_id',
		'product_brand'	=> 'dhvc_woo_brand_page_id'
	);
	if(array_key_exists($taxonomy, $setting_fields)){
		return $setting_fields[$taxonomy];
	}
	return false;
}

function _dhwc_layout_get_product_frist_thumbnail($product,$size='shop_catalog') {
	global $product;
	$found = '';
	$thumbnail_size = 'shop_catalog';
	$attachment_ids = $product->get_gallery_image_ids();
	if ( $attachment_ids ) {
		foreach ( $attachment_ids as $attachment_id ) {
			if ( get_post_meta( $attachment_id, '_woocommerce_exclude_image' ) ){
				continue;
			}
			
			if('shop_catalog'===$size){
				$found = wp_get_attachment_image( $attachment_id, $thumbnail_size, false, array('class'=>'hover-image') );
			}else{
				$image_resize =  dhwc_layout_get_image_by_size(array( 'attach_id' => $attachment_id, 'thumb_size' => $size ));
				$found = $image_resize['thumbnail'];
			}
			if(!empty($found)){
				break;
			}
		}
	}
	return $found;
}

function dhwc_layout_get_product_thumbnail($product,$size='shop_catalog') {
	$frist = _dhwc_layout_get_product_frist_thumbnail($product,$size);
	if('shop_catalog' === $size){
		$thumbnail_data = get_the_post_thumbnail( $product->get_id(), 'shop_catalog' );
		return '<div class="dhvc-woo-thumbnail'.($frist != '' ? ' dhvc-woo-front-thumbnail':'').'">' . $thumbnail_data .'</div>';
	}else{
		$thumbnail_data = dhwc_layout_get_image_by_size(array( 'post_id' => $product->get_id(), 'thumb_size' => $size ));
		return '<div class="dhvc-woo-thumbnail'.($frist != '' ? ' dhvc-woo-front-thumbnail':'').'">' . $thumbnail_data['thumbnail'] .'</div>';
	}
}

function dhwc_layout_get_product_frist_thumbnail($product,$size='shop_catalog') {
	if ( ( $frist = _dhwc_layout_get_product_frist_thumbnail($product,$size) ) != '' ) {
		return '<div class="dhvc-woo-thumbnail dhvc-woo-back-thumbnail">' . $frist . '</div>';
	}
}

function dhwc_layout_template_part(){
	return 'dhvc-woocommerce/';
}

function dhwc_layout_get_template($template_name, $args = array(), $template_path = '', $default_path = ''){
	if ( $args && is_array( $args ) ) {
		extract( $args );
	}
	if ( ! $template_path ) {
		$template_path = dhwc_layout_template_part();
	}
	
	if ( ! $default_path ) {
		$default_path = DHVC_WOO_DIR . '/templates/';
	}
	
	// Look within passed path within the theme - this is priority.
	$located = locate_template(
		array(
			trailingslashit( $template_path ) . $template_name,
			$template_name,
		)
	);
	// Get default template/.
	if ( ! $located || WC_TEMPLATE_DEBUG_MODE ) {
		$located = $default_path . $template_name;
	}
	
	if ( ! file_exists( $located ) ) {
		_doing_it_wrong( __FUNCTION__, sprintf( '<code>%s</code> does not exist.', $template_name ), null );
		return;
	}
	
	$located = apply_filters( 'dhwc_layout_get_template', $located, $template_name, $args, $template_path, $default_path );

	do_action( 'dhwc_layout_before_template', $template_name, $template_path, $located, $args );
	include ( $located );
	do_action( 'dhwc_layout_after_template', $template_name, $template_path, $located, $args );
}

function dhwc_layout_css_minify( $css ) {
	$css = preg_replace( '/\s+/', ' ', $css );
	$css = preg_replace( '/\/\*[^\!](.*?)\*\//', '', $css );
	$css = preg_replace( '/(,|:|;|\{|}) /', '$1', $css );
	$css = preg_replace( '/ (,|;|\{|})/', '$1', $css );
	$css = preg_replace( '/(:| )0\.([0-9]+)(%|em|ex|px|in|cm|mm|pt|pc)/i', '${1}.${2}${3}', $css );
	$css = preg_replace( '/(:| )(\.?)0(%|em|ex|px|in|cm|mm|pt|pc)/i', '${1}0', $css );
	return trim( $css );
}

/**
 * @deprecated 3.0.0
 */
function dhvc_woo_the_category_page_content(){
	_deprecated_function( 'dhvc_woo_the_category_page_content', '3.0.0', 'dhwc_layout_the_custom_content' );
	dhwc_layout_the_custom_content();
}

/**
 * @deprecated 3.0.0
 */
function dhvc_woo_the_tag_page_content(){
	_deprecated_function( 'dhvc_woo_the_tag_page_content', '3.0.0', 'dhwc_layout_the_custom_content' );
	dhwc_layout_the_custom_content();
}
/**
 * @deprecated 3.0.0
 */
function dhvc_woo_the_brand_page_content(){
	_deprecated_function( 'dhvc_woo_the_tag_page_content', '3.0.0', 'dhwc_layout_the_custom_content' );
	dhwc_layout_the_custom_content();
}

/**
 * Display custom content
 */
function dhwc_layout_the_custom_content(){
	global $dhwc_layout_custom_content_template;
	if(!empty($dhwc_layout_custom_content_template)){
		$content = $dhwc_layout_custom_content_template->post_content;
		$content = apply_filters( 'the_content', $content );
		$content = str_replace( ']]>', ']]&gt;', $content );
		$content = apply_filters('dhwc_layout_the_custom_content',$content);
		echo $content;
	}
}


function _dhwc_layout_get_rand_id(){
	return uniqid('dhwc_layout_');
}

function dhwc_layout_param_field_id($settings, $value){
	if(empty($value)){
	 	$value = _dhwc_layout_get_rand_id();
	 }
	return '<input name="'.$settings['param_name'].'" class="wpb_vc_param_value dhwc-layout-param-value wpb-textinput" type="hidden" value="'.$value.'"/>';
}


function dhwc_layout_param_field_heading($settings, $value, $dependency=''){
	return '<div style="background: none repeat scroll 0 0 #E1E1E1;font-size: 14px;font-weight: bold;padding: 5px;">'.$value.'</div>';
}

function dhwc_layout_param_field_products_ajax($settings, $value,$dependency=''){
	$product_ids = array();
	
	if(!empty($value)){
		$product_ids = array_map( 'absint', explode( ',', $value ) );
	}
	$output = '<select id= "'.$settings['param_name'].'" '.$dependency.' multiple="multiple" class="dhwc-layout-select dhwc_layout_ajax_products" style="width: 100%;">';
	if(!empty($product_ids)){
		foreach ( $product_ids as $product_id ) {
			$product = get_product( $product_id );
			$output .= '<option value="' . esc_attr( $product_id ) . '" selected="selected">' . wp_kses_post( dhwc_layout_get_product_formatted_name($product) ) . '</option>';
		}
	}
	$output .= '</select>';
	$output .='<input id= "'.$settings['param_name'].'" type="hidden" class="wpb_vc_param_value dhwc-layout-param-value wpb-textinput" name="'.$settings['param_name'].'" value="'.$value.'" />';
	return $output;
}

if (!function_exists( 'dhwc_layout_resize' )) {
	function dhwc_layout_resize( $attach_id = null, $img_url = null, $width, $height, $crop = false ) {
		// this is an attachment, so we have the ID
		if ( $attach_id ) {
			$image_src = wp_get_attachment_image_src( $attach_id, 'full' );
			$actual_file_path = get_attached_file( $attach_id );
			// this is not an attachment, let's use the image url
		} else if ( $img_url ) {
			$file_path = parse_url( $img_url );
			$actual_file_path = $_SERVER['DOCUMENT_ROOT'] . $file_path['path'];
			$actual_file_path = ltrim( $file_path['path'], '/' );
			$actual_file_path = rtrim( ABSPATH, '/' ).$file_path['path'];
			$orig_size = getimagesize( $actual_file_path );
			$image_src[0] = $img_url;
			$image_src[1] = $orig_size[0];
			$image_src[2] = $orig_size[1];
		}
		$file_info = pathinfo( $actual_file_path );
		$extension = '.'. $file_info['extension'];

		// the image path without the extension
		$no_ext_path = $file_info['dirname'].'/'.$file_info['filename'];

		$cropped_img_path = $no_ext_path.'-'.$width.'x'.$height.$extension;

		// checking if the file size is larger than the target size
		// if it is smaller or the same size, stop right here and return
		if ( $image_src[1] > $width || $image_src[2] > $height ) {

			// the file is larger, check if the resized version already exists (for $crop = true but will also work for $crop = false if the sizes match)
			if ( file_exists( $cropped_img_path ) ) {
				$cropped_img_url = str_replace( basename( $image_src[0] ), basename( $cropped_img_path ), $image_src[0] );
				$vt_image = array (
					'url' 		=> $cropped_img_url,
					'width' 	=> $width,
					'height' 	=> $height
				);
				return $vt_image;
			}

			// $crop = false
			if ( $crop == false ) {
				// calculate the size proportionaly
				$proportional_size = wp_constrain_dimensions( $image_src[1], $image_src[2], $width, $height );
				$resized_img_path = $no_ext_path.'-'.$proportional_size[0].'x'.$proportional_size[1].$extension;

				// checking if the file already exists
				if ( file_exists( $resized_img_path ) ) {
					$resized_img_url = str_replace( basename( $image_src[0] ), basename( $resized_img_path ), $image_src[0] );

					$vt_image = array (
						'url' => $resized_img_url,
						'width' => $proportional_size[0],
						'height' => $proportional_size[1]
					);
					return $vt_image;
				}
			}

			// no cache files - let's finally resize it
			$img_editor =  wp_get_image_editor($actual_file_path);

			if ( is_wp_error($img_editor) || is_wp_error( $img_editor->resize($width, $height, $crop)) ) {
				return array (
					'url' => '',
					'width' => '',
					'height' => ''
				);
			}

			$new_img_path = $img_editor->generate_filename();

			if ( is_wp_error( $img_editor->save( $new_img_path ) ) ) {
				return array (
					'url' => '',
					'width' => '',
					'height' => ''
				);
			}

			if(!is_string($new_img_path)) {
				return array (
					'url' => '',
					'width' => '',
					'height' => ''
				);
			}

			$new_img_size = getimagesize( $new_img_path );
			$new_img = str_replace( basename( $image_src[0] ), basename( $new_img_path ), $image_src[0] );

			// resized output
			$vt_image = array (
				'url' => $new_img,
				'width' => $new_img_size[0],
				'height' => $new_img_size[1]
			);
			return $vt_image;
		}

		// default output - without resizing
		$vt_image = array (
			'url' => $image_src[0],
			'width' => $image_src[1],
			'height' => $image_src[2]
		);
		return $vt_image;
	}
}

function dhwc_layout_get_image_by_size( $params = array( 'post_id' => NULL, 'attach_id' => NULL, 'thumb_size' => 'thumbnail', 'class' => '' )){
	//array( 'post_id' => $post_id, 'thumb_size' => $grid_thumb_size )
	if ( (!isset($params['attach_id']) || $params['attach_id'] == NULL) && (!isset($params['post_id']) || $params['post_id'] == NULL) ) return;
	$post_id = isset($params['post_id']) ? $params['post_id'] : 0;
	
	if ( $post_id ) $attach_id = get_post_thumbnail_id($post_id);
	else $attach_id = $params['attach_id'];
	
	$thumb_size = $params['thumb_size'];
	$thumb_class = (isset($params['class']) && $params['class']!='') ? $params['class'].' ' : '';
	
	global $_wp_additional_image_sizes;
	$thumbnail = '';
	
	if ( is_string($thumb_size) && ((!empty($_wp_additional_image_sizes[$thumb_size]) && is_array($_wp_additional_image_sizes[$thumb_size])) || in_array($thumb_size, array('thumbnail', 'thumb', 'medium', 'large', 'full') ) ) ) {
		//$thumbnail = get_the_post_thumbnail( $post_id, $thumb_size );
		$thumbnail = wp_get_attachment_image( $attach_id, $thumb_size, false, array('class' => $thumb_class.'attachment-'.$thumb_size) );
		//TODO APPLY FILTER
	} elseif( $attach_id ) {
		if ( is_string($thumb_size) ) {
			preg_match_all('/\d+/', $thumb_size, $thumb_matches);
			if(isset($thumb_matches[0])) {
				$thumb_size = array();
				if(count($thumb_matches[0]) > 1) {
					$thumb_size[] = $thumb_matches[0][0]; // width
					$thumb_size[] = $thumb_matches[0][1]; // height
				} elseif(count($thumb_matches[0]) > 0 && count($thumb_matches[0]) < 2) {
					$thumb_size[] = $thumb_matches[0][0]; // width
					$thumb_size[] = $thumb_matches[0][0]; // height
				} else {
					$thumb_size = false;
				}
			}
		}
		if (is_array($thumb_size)) {
			// Resize image to custom size
			$p_img = dhwc_layout_resize($attach_id, null, $thumb_size[0], $thumb_size[1], true);
			$alt = trim(strip_tags( get_post_meta($attach_id, '_wp_attachment_image_alt', true) ));
	
			if ( empty($alt) ) {
				$attachment = get_post($attach_id);
				$alt = trim(strip_tags( $attachment->post_excerpt )); // If not, Use the Caption
			}
			if ( empty($alt) )
				$alt = trim(strip_tags( $attachment->post_title )); // Finally, use the title
			if ( $p_img ) {
				$img_class = '';
				$thumbnail = '<img class="'.$thumb_class.'" src="'.$p_img['url'].'" width="'.$p_img['width'].'" height="'.$p_img['height'].'" alt="'.$alt.'" />';
			}
		}
	}
	
	$p_img_large = wp_get_attachment_image_src($attach_id, 'large' );
	return array( 'thumbnail' => $thumbnail, 'p_img_large' => $p_img_large );
}

function dhwc_layout_ajax_search_products(){
	
	if ( empty( $term ) && isset( $_GET['term'] ) ) {
		$term = (string) wc_clean( wp_unslash( $_GET['term'] ) );
	}
	
	if ( empty( $term ) ) {
		wp_die();
	}
	
	if ( ! empty( $_GET['limit'] ) ) {
		$limit = absint( $_GET['limit'] );
	} else {
		$limit = absint( apply_filters( 'woocommerce_json_search_limit', 30 ) );
	}
	
	$data_store = WC_Data_Store::load( 'product' );
	$ids        = $data_store->search_products( $term, '', false , false, $limit);

	$product_objects = array_filter( array_map( 'wc_get_product', $ids ), 'wc_products_array_filter_readable' );
	$products        = array();
	
	foreach ( $product_objects as $product_object ) {
		$formatted_name = $product_object->get_formatted_name();
		$managing_stock = $product_object->managing_stock();
		
		if ( in_array( $product_object->get_type(), $exclude_types, true ) ) {
			continue;
		}
		
		$products[ $product_object->get_id() ] = rawurldecode( $formatted_name );
	}
	
	wp_send_json( $products );
}

add_action('wp_ajax_dhwc_layout_search_products', 'dhwc_layout_ajax_search_products');

function dhwc_layout_get_product_formatted_name(WC_Product $product){
	if ( $product->get_sku() ) {
		$identifier = $product->get_sku() ;
	} else {
		$identifier = '#' . $product->get_id();
	}
	return sprintf( __( '%s &ndash; %s', DHVC_WOO ), $identifier, $product->get_title() );
}

function dhwc_layout_param_field_categories($settings, $value,$dependency=''){
	$category_ids = explode(',',$value);
	$args = array(
			'orderby' => 'name',
			'hide_empty' => 0,
	);
	$categories = get_terms( 'product_cat', $args );
	$output = '<select '.$dependency.' id= "'.$settings['param_name'].'" multiple="multiple" class="dhwc-layout-select dhwc_layout_select2_nostd" style="width: 100%;">';
	$output .= '<option value="">' . esc_html(__('-- Select --',DHVC_WOO) ) . '</option>';
	if( ! empty($categories)){
		foreach ($categories as $cat):
			$output .= '<option value="' . esc_attr( $cat->term_id ) . '"' . selected( in_array( $cat->term_id, $category_ids ), true, false ) . '>' . esc_html( $cat->name ) . '</option>';
		endforeach;
	}
	$output .= '</select>';
	$output .='<input id= "'.$settings['param_name'].'" type="hidden" class="wpb_vc_param_value dhwc-layout-param-value wpb-textinput" name="'.$settings['param_name'].'" value="'.$value.'" />';
	return $output;
}

function dhwc_layout_param_field_brands($settings, $value,$dependency=''){
	$brands_ids = explode(',',$value);
	$args = array(
		'orderby' => 'name',
		'hide_empty' => 0,
	);
	$brands = get_terms( 'product_brand', $args );
	$output = '<select '.$dependency.' id= "'.$settings['param_name'].'" multiple="multiple" class="dhwc-layout-select dhwc_layout_select2_nostd" style="width: 100%;">';
	if( ! empty($brands) && !is_wp_error($brands)){
		foreach ($brands as $brand):
			$output .= '<option value="' . esc_attr( $brand->term_id ) . '"' . selected( in_array( $brand->term_id, $brands_ids ), true, false ) . '>' . esc_html( $brand->name ) . '</option>';
		endforeach;
	}
	$output .= '</select>';
	$output .='<input id= "'.$settings['param_name'].'" type="hidden" class="wpb_vc_param_value dhwc-layout-param-value wpb-textinput" name="'.$settings['param_name'].'" value="'.$value.'" />';
	return $output;
}
function dhwc_layout_param_field_tags($settings, $value,$dependency=''){
	$tags_ids = explode(',',$value);
	$args = array(
		'orderby' => 'name',
		'hide_empty' => 0,
	);
	$tags = get_terms( 'product_tag', $args );
	$output = '<select '.$dependency.' id= "'.$settings['param_name'].'" multiple="multiple" class="dhwc-layout-select dhwc_layout_select2_nostd" style="width: 100%;">';
	if( ! empty($tags)){
		foreach ($tags as $tag):
			$output .= '<option value="' . esc_attr( $tag->term_id ) . '"' . selected( in_array( $tag->term_id, $tags_ids ), true, false ) . '>' . esc_html( $tag->name ) . '</option>';
		endforeach;
	}
	$output .= '</select>';
	$output .='<input id= "'.$settings['param_name'].'" type="hidden" class="wpb_vc_param_value dhwc-layout-param-value wpb-textinput" name="'.$settings['param_name'].'" value="'.$value.'" />';
	return $output;
}

function dhwc_layout_param_field_attributes($settings, $value,$dependency=''){
	$attributes_ids = explode(',', $value);
	$attributes = wc_get_attribute_taxonomies();
	$output = '<select '.$dependency.' id= "'.$settings['param_name'].'" multiple="multiple" class="dhwc-layout-select dhwc_layout_select2_nostd" style="width: 100%;">';
	if($attributes){
		foreach ($attributes as $tax):
			if ( taxonomy_exists( wc_attribute_taxonomy_name( $tax->attribute_name ) ) ){
				$output .= '<optgroup label="'.$tax->attribute_name.'">';
					$args = array(
						'orderby' => 'name'
					);
					if ( $name = wc_attribute_taxonomy_name( $tax->attribute_name ) ) {
						$terms = get_terms( $name, $args );
						if(!empty($terms)){
							foreach ($terms as $term){
								$v =  $name.'|'.$term->slug;
								$output .= '<option value="' . esc_attr($v) . '"' . selected( in_array($v, $attributes_ids ), true, false ) . '>' . esc_html( $term->name ) . '</option>';
							}
						}
					}
				$output .='</optgroup>';
			}
		endforeach;
	}
	$output .= '</select>';
	$output .='<input id= "'.$settings['param_name'].'" type="hidden" class="wpb_vc_param_value dhwc-layout-param-value wpb-textinput" name="'.$settings['param_name'].'" value="'.$value.'" />';
	return $output;
}

function dhwc_layout_get_setting_params(){
	return apply_filters('dhwc_layout_setting_params',array(
		array (
			'type' 			=> 'dhwc_layout_param_field_id',
			'param_name' 	=> 'id'
		),
		array (
			'save_always'	=> true,
			'type' 			=> 'textfield',
			'class' 		=> '',
			'heading' 		=> __ ( 'Heading', DHVC_WOO ),
			'admin_label'	=> true,
			'param_name' 	=> 'heading'
		),
		array (
			'save_always'	=> true,
			'type' 			=> 'colorpicker',
			'class' 		=> '',
			'heading' 		=> __ ( 'Heading Color', DHVC_WOO ),
			'param_name' 	=> 'heading_color',
			'value' 		=> '#47A3DA',
		),
		array (
			'save_always'	=> true,
			'type' 			=> 'textfield',
			'class' 		=> '',
			'heading' 		=> __ ( 'Heading Font Size', DHVC_WOO ),
			'param_name' 	=> 'heading_font_size',
			'value' 		=> '20px',
			'description' 	=> __ ( 'Enter your custom size. Example: 20px.', DHVC_WOO ),
		),
		array (
			'type' 			=> 'dhwc_layout_field_heading',
			'value' 		=> 'Query Options',
			'param_name' 	=> 'query_options'
		),
		array (
			'save_always'	=> true,
			'type' 			=> 'dropdown',
			'heading'		=> __( 'Query Type', DHVC_WOO ),
			'param_name' 	=> 'query_type',
			'std'			=> 'build',
			'admin_label'	=> true,
			'value' => array (
				__( 'Build Query', DHVC_WOO ) 			=> 'build',
				__( 'Use Main Query', DHVC_WOO ) 		=> 'main',
				__( 'Up-Sells Product', DHVC_WOO ) 		=> 'upsell',
				__( 'Cross-Sells Product', DHVC_WOO ) 	=> 'crosssell',
				__( 'Related Product', DHVC_WOO ) 		=> 'related',
			)
		),
		array (
			'save_always'	=> true,
			'type' 			=> 'autocomplete',
			'settings' 		=> array(
				'multiple' 		=> true,
				'sortable' 		=> true,
				'unique_values' => true,
			),
			'heading' 		=> __('Products',DHVC_WOO),
			'param_name' 	=> 'products',
			'group' 		=> __( 'Build Query', DHVC_WOO ),
			'dependency' 	=> array (
				'element' => 'query_type',
				'value'   => array ('build'),
			)
		),
		
		array (
			'save_always'	=> true,
			'type' 			=> 'autocomplete',
			'settings' 		=> array(
				'multiple' 		=> true,
				'sortable' 		=> true,
				'unique_values' => true,
			),
			'heading' 		=> __('Exclude Products',DHVC_WOO),
			'param_name' 	=> 'exclude_products',
			'group' 		=> __( 'Build Query', DHVC_WOO ),
			'dependency' 	=> array (
				'element' 	=> 'query_type',
				'value' 	=> array ('build'),
			)
		),
		array (
			'save_always'	=> true,
			'type' 			=> 'autocomplete',
			'settings' 		=> array(
				'multiple' => true,
				'sortable' => true,
			),
			'heading' 		=> __( 'Categories', DHVC_WOO ),
			'param_name' 	=> 'category',
			'group' 		=> __( 'Build Query', DHVC_WOO ),
			'dependency' 	=> array (
				'element' 	=> 'query_type',
				'value'		=> array ('build')
			)
		),
		array (
			'save_always'	=> true,
			'type' 			=> 'autocomplete',
			'settings' 		=> array(
				'multiple' => true,
				'sortable' => true,
			),
			'heading' 		=> __( 'Exclude Categories', DHVC_WOO ),
			'param_name' 	=> 'exclude_category',
			'group' 		=> __( 'Build Query', DHVC_WOO ),
			'dependency' 	=> array (
				'element' 	=> 'query_type',
				'value' 	=> array ('build')
			)
		),
		array (
			'save_always'=>true,
			'type' => 'autocomplete',
			'settings' => array(
				'multiple' => true,
				'sortable' => true,
			),
			'heading' => __( 'Brands', DHVC_WOO ),
			'param_name' => 'brand',
			'group' => __( 'Build Query', DHVC_WOO ),
			'dependency' => array (
				'element' => 'query_type',
				'value' => array ('build')
			)
		),
		array (
			'save_always'=>true,
			'type' => 'autocomplete',
			'settings' => array(
				'multiple' => true,
				'sortable' => true,
			),
			'heading' => __( 'Exclude Brands', DHVC_WOO ),
			'param_name' => 'exclude_brand',
			'group' => __( 'Build Query', DHVC_WOO ),
			'dependency' => array (
				'element' => 'query_type',
				'value' => array ('build')
			)
		),
		array (
			'save_always'=>true,
			'type' => 'autocomplete',
			'settings' => array(
				'multiple' => true,
				'sortable' => true,
			),
			'heading' => __( 'Tags', DHVC_WOO ),
			'param_name' => 'tag',
			'group' => __( 'Build Query', DHVC_WOO ),
			'dependency' => array (
				'element' => 'query_type',
				'value' => array ('build')
			)
		),
		array (
			'save_always'=>true,
			'type' => 'autocomplete',
			'settings' => array(
				'multiple' => true,
				'sortable' => true,
			),
			'heading' => __( 'Exclude Tags', DHVC_WOO ),
			'param_name' => 'exclude_tag',
			'group' => __( 'Build Query', DHVC_WOO ),
			'dependency' => array (
				'element' => 'query_type',
				'value' => array ('build')
			)
		),
		array (
			'save_always'=>true,
			'type' => 'dhwc_layout_field_attributes',
			'heading' => __( 'Attributes', DHVC_WOO ),
			'param_name' => 'attribute',
			'group' => __( 'Build Query', DHVC_WOO ),
			'dependency' => array (
				'element' => 'query_type',
				'value' => array ('build')
			)
		),
		array (
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Products Per Page', DHVC_WOO ),
			'param_name' => 'posts_per_page',
			'value' => '8',
			'dependency' => array (
				'element' => 'query_type',
				'value' => array ('build','upsell','crosssell','related')
			),
			'description'=>__('number of post to show per page. If value -1 to show all posts',DHVC_WOO)
		),
		array (
			'save_always'=>true,
			'type' => 'dropdown',
			'heading' => __( 'Products Per Row', DHVC_WOO ),
			'param_name' => 'post_per_row',
			'dependency' => array (
				'element' => 'query_type',
				'value' => array ('build','main','upsell','crosssell','related')
			),
			'std'=>'3',
			'admin_label'=>true,
			'value' => array (
				__( '2', DHVC_WOO ) => '2',
				__( '3', DHVC_WOO ) => '3',
				__( '4', DHVC_WOO ) => '4',
				__( '5', DHVC_WOO ) => '5',
				__( '6', DHVC_WOO ) => '6'
			)
		),
		array (
			'save_always'=>true,
			'type' => 'dropdown',
			'heading' => __( 'Show', DHVC_WOO ),
			'param_name' => 'show',
			'group' => __( 'Build Query', DHVC_WOO ),
			'dependency' => array (
				'element' => 'query_type',
				'value' => array (
					'build','upsell','crosssell','related'
				)
			),
			'value' => array (
				__( 'All Products', DHVC_WOO ) 		=> '',
				__( 'Featured Products', DHVC_WOO ) => 'featured',
				__( 'On-sale Products', DHVC_WOO ) 	=> 'onsale'
			),
		),
	    array (
	        'save_always'=>true,
	        'type' => 'dropdown',
	        'heading' => __( 'Stock status', DHVC_WOO ),
	        'param_name' => 'stock_status',
	        'group' => __( 'Build Query', DHVC_WOO ),
	        'dependency' => array (
	            'element' => 'query_type',
	            'value' => array (
	                'build','upsell','crosssell','related'
	            )
	        ),
	        'value' => array (
	            __( 'All Products', DHVC_WOO ) => '',
	            __( 'In stock', DHVC_WOO )     => 'instock',
	            __( 'Out of stock', DHVC_WOO ) => 'outofstock',
	            __( 'On backorder', DHVC_WOO ) => 'onbackorder'
	        ),
	    ),
		array (
			'save_always'=>true,
			'type' => 'dropdown',
			'heading' => __( 'Products Ordering', DHVC_WOO ),
			'param_name' => 'orderby',
			'std'=>'date',
			'group' => __( 'Build Query', DHVC_WOO ),
			'dependency' => array (
				'element' => 'query_type',
				'value' => array (
					'build','upsell','crosssell','related'
				)
			),
			'admin_label'=>true,
			'value' => array (
				__( 'Publish Date', DHVC_WOO ) => 'date',
				__( 'Modified Date', DHVC_WOO ) => 'modified',
				__( 'Random', DHVC_WOO ) => 'rand',
				__( 'Alphabetic', DHVC_WOO ) => 'title',
				__( 'Comment Count', DHVC_WOO ) => 'comment_count',
				__( 'Price', DHVC_WOO ) => 'price',
				__( 'Sales', DHVC_WOO ) => 'sales',
				__( 'Popularity',DHVC_WOO)=>'popularity',
				__( 'Rating', DHVC_WOO ) => 'rating',
			),
		),
		array (
			'save_always'=>true,
			'type' => 'dropdown',
			'admin_label'=>true,
			'heading' => __( 'Ascending or Descending', DHVC_WOO ),
			'group' => __( 'Build Query', DHVC_WOO ),
			'param_name' => 'order',
			'dependency' => array (
				'element' => 'query_type',
				'value' => array (
					'build','upsell','crosssell','related'
				)
			),
			'description' => __( 'After the Sort Order is selected, the products will be sorted by this condition', DHVC_WOO ),
			'value' => array (
				__( 'Ascending', DHVC_WOO ) => 'ASC',
				__( 'Descending', DHVC_WOO ) => 'DESC'
			),
		),
		array (
			'save_always'=>true,
			'type' => 'checkbox',
			'group' => __( 'Build Query', DHVC_WOO ),
			'dependency' => array (
				'element' => 'query_type',
				'value' => array (
					'build','upsell','crosssell','related'
				)
			),
			'heading' => __( 'Hide free products', DHVC_WOO ),
			'param_name' => 'hide_free',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'save_always'=>true,
			'type' => 'checkbox',
			'group' => __( 'Build Query', DHVC_WOO ),
			'heading' => __( 'Show hidden products', DHVC_WOO ),
			'param_name' => 'show_hidden',
			'dependency' => array (
				'element' => 'query_type',
				'value' => array (
					'build','upsell','crosssell','related'
				)
			),
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'type' => 'dhwc_layout_field_heading',
			'value' => 'Style Options',
			'param_name' => 'style_options'
		),
		array (
			'save_always'=>true,
			'type' => 'dropdown',
			'heading' => __( 'Display type', DHVC_WOO ),
			'param_name' => 'display',
			'std'=>'grid',
			'admin_label'=>true,
			'value' => array (
				__( 'Grid', DHVC_WOO ) => 'grid',
				__( 'Grid Flex', DHVC_WOO ) => 'flex',
				__( 'List', DHVC_WOO ) => 'list',
				__( 'Masonry', DHVC_WOO ) => 'masonry',
				__( 'Carousel', DHVC_WOO ) => 'carousel'
			)
		),
		array (
			'save_always'=>true,
			'type' => 'dropdown',
			'heading' => __( 'Use default style of Theme', DHVC_WOO ),
			'param_name' => 'use_default_style_of_theme',
			'value' => array (
				__( 'No', DHVC_WOO ) => 'no',
				__( 'Yes', DHVC_WOO ) => 'yes'
			),
			'description'=>__('User default style of Theme (only work with Grid layout)',DHVC_WOO),
			'dependency' => array (
				'element' => 'display',
				'value' => array ('grid')
			)
		),
		
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Show Rating', DHVC_WOO ),
			'param_name' => 'show_rating',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hide Sale flash', DHVC_WOO ),
			'param_name' => 'hide_sale_flash',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Show Out of stock flash', DHVC_WOO ),
			'param_name' => 'show_out_of_stock_flash',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Out of stock text', DHVC_WOO ),
			'group' => __( 'Style settings', DHVC_WOO ),
			'param_name' => 'out_of_stock_text',
			'value' => 'Out of stock',
			'dependency' => array (
				'element' => 'show_out_of_stock_flash',
				'value' => array (
					'yes'
				)
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Show Quick view', DHVC_WOO ),
			'param_name' => 'show_quickview',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hide Result Count', DHVC_WOO ),
			'param_name' => 'hide_result_count',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hide Ordering', DHVC_WOO ),
			'param_name' => 'hide_ordering_list',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hide Pagination', DHVC_WOO ),
			'param_name' => 'hide_grid_pagination',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			),
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'flex',
					'grid',
					'list'
				)
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'dhwc_layout_field_heading',
			'param_name' => 'layout_settings'
		),
		array (
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Show Masonry Filters', DHVC_WOO ),
			'group' => __( 'Style settings', DHVC_WOO ),
			'param_name' => 'show_masonry_filter',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			),
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'masonry'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Masonry Filters Background', DHVC_WOO ),
			'param_name' => 'masonry_filters_background',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => '',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'masonry'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Masonry Filters Selected Background', DHVC_WOO ),
			'param_name' => 'masonry_filters_selected_background',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => '',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'masonry'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Masonry Filters Color', DHVC_WOO ),
			'param_name' => 'masonry_filters_color',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => '',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'masonry'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Masonry Filters Selected Color', DHVC_WOO ),
			'param_name' => 'masonry_filters_selected_color',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => '',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'masonry'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Masonry Filters Border Color', DHVC_WOO ),
			'param_name' => 'masonry_filters_border_color',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => '#ffffff',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'masonry'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Masonry Filters Selected Border Color', DHVC_WOO ),
			'param_name' => 'masonry_filters_selected_border_color',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => '',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'masonry'
				)
			)
		),
		array (
			'type' => 'checkbox',
			'heading' => __( 'Carousel Auto Play', DHVC_WOO ),
			'param_name' => 'carousel_autoplay',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			),
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'carousel'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Carousel Auto Play Timeout', DHVC_WOO ),
			'param_name' => 'carousel_autoplay_timeout',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => '2000',
			'description' => __( 'Enter your timeout. Example: 1000.', DHVC_WOO ),
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'carousel'
				)
			)
		),
		array (
			'type' => 'checkbox',
			'heading' => __( 'Hide Carousel Arrows', DHVC_WOO ),
			'param_name' => 'hide_carousel_arrows',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			),
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'carousel'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Carousel Arrows Size', DHVC_WOO ),
			'param_name' => 'carousel_arrow_size',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => '',
			'description' => __( 'Enter your custom size. Example: 24px.', DHVC_WOO ),
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'carousel'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Show Carousel Pagination', DHVC_WOO ),
			'param_name' => 'show_carousel_pagination',
			'group' => __( 'Style settings', DHVC_WOO ),
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			),
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'carousel'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'colorpicker',
			'group' => __( 'Style settings', DHVC_WOO ),
			'heading' => __( 'Carousel Pagination Background', DHVC_WOO ),
			'param_name' => 'carousel_pagination_background',
			'value' => '',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'carousel'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'colorpicker',
			'group' => __( 'Style settings', DHVC_WOO ),
			'heading' => __( 'Carousel Pagination Active Background', DHVC_WOO ),
			'param_name' => 'carousel_pagination_active_background',
			'value' => '',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'carousel'
				)
			)
		),
		array (
			'save_always'=>true,
			'type' => 'textfield',
			'group' => __( 'Style settings', DHVC_WOO ),
			'heading' => __( 'Carousel Pagination Size', DHVC_WOO ),
			'param_name' => 'carousel_pagination_size',
			'value' => '',
			'description' => __( 'Enter your custom size. Example: 12px.', DHVC_WOO ),
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'carousel'
				)
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'dhwc_layout_field_heading',
			'value' => 'Style Options',
			'param_name' => 'style_options'
		),
		array (
			'save_always'=>true,
			'type' => 'dropdown',
			'group' => __( 'Style settings', DHVC_WOO ),
			'heading' => __( 'Item Border Style', DHVC_WOO ),
			'param_name' => 'item_border_style',
			'value' => array (
				__( 'Solid', DHVC_WOO ) => 'solid',
				__( 'Dashed', DHVC_WOO ) => 'dashed',
				__( 'Dotted', DHVC_WOO ) => 'dotted',
				__( 'None', DHVC_WOO ) => 'none'
			),
			
		),
		array (
			'save_always'=>true,
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'colorpicker',
			'heading' => __( 'Item Border Color', DHVC_WOO ),
			'param_name' => 'item_border_color',
			'value' => '',
			
		),
		array (
			'save_always'=>true,
			'type' => 'textfield',
			'group' => __( 'Style settings', DHVC_WOO ),
			'heading' => __( 'Item Border Width', DHVC_WOO ),
			'param_name' => 'item_border_width',
			'value' => '',
			'description' => __( 'Enter your custom item border width . Example: 5px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'dhwc_layout_field_heading',
			'value' => 'Style Options',
			'param_name' => 'style_options'
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hide Thumbnail', DHVC_WOO ),
			'param_name' => 'hide_thumbnail',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hover Thumbnail Effects', DHVC_WOO ),
			'param_name' => 'hover_thumbnail',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'save_always'=>true,
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'colorpicker',
			'heading' => __( 'Thumbnail Background Color', DHVC_WOO ),
			'param_name' => 'thumbnail_background_color',
			'value' => ''
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'dropdown',
			'heading' => __( 'Thumbnail Border Style', DHVC_WOO ),
			'param_name' => 'thumbnail_border_style',
			'value' => array (
				__( 'Solid', DHVC_WOO ) => 'solid',
				__( 'Dashed', DHVC_WOO ) => 'dashed',
				__( 'Dotted', DHVC_WOO ) => 'dotted',
				__( 'None', DHVC_WOO ) => 'none'
			),
			'std'=>'none'
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Thumbnail Border Color', DHVC_WOO ),
			'param_name' => 'thumbnail_border_color',
			'value' => ''
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Thumbnail Border Width', DHVC_WOO ),
			'param_name' => 'thumbnail_border_width',
			'value' => '',
			'description' => __( 'Enter your custom thumbnail border width . Example: 2px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Thumbnail Border Radius', DHVC_WOO ),
			'param_name' => 'thumbnail_border_radius',
			'value' => '',
			'description' => __( 'Enter your custom thumbnail border radius . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Thumbnail Padding', DHVC_WOO ),
			'param_name' => 'thumbnail_padding',
			'value' => '',
			'description' => __( 'Enter your custom thumbnail padding . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Thumbnail Margin', DHVC_WOO ),
			'param_name' => 'thumbnail_margin',
			'value' => '',
			'description' => __( 'Enter your custom thumbnail margin . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Box Thumbnail Width', DHVC_WOO ),
			'param_name' => 'box_thumbnail_width',
			'value' => '',
			'description' => __( 'Enter width for box thumbnail, if empty will use thumbnail image width.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Image Thumbnail Width', DHVC_WOO ),
			'param_name' => 'thumbnail_width',
			'description' => __( 'Enter your custom image thumbnail width . Example: 200.', DHVC_WOO ),
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Image Thumbnail Height', DHVC_WOO ),
			'param_name' => 'thumbnail_height',
			'description' => __( 'Enter your custom image thumbnail height . Example: 200.', DHVC_WOO ),
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'dhwc_layout_field_heading',
			'value' => 'Style Options',
			'param_name' => 'style_options'
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hide Title', DHVC_WOO ),
			'param_name' => 'hide_title',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'dropdown',
			'heading' => __( 'Title Align', DHVC_WOO ),
			'param_name' => 'title_align',
			'std'=>'left',
			'value' => array (
				__( 'Left', DHVC_WOO ) => 'left',
				__( 'Center', DHVC_WOO ) => 'center',
				__( 'Right', DHVC_WOO ) => 'right'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Title Color', DHVC_WOO ),
			'param_name' => 'title_color',
			'value' => ''
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Title Hover Color', DHVC_WOO ),
			'param_name' => 'title_hover_color',
			'value' => ''
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Title Font Size', DHVC_WOO ),
			'param_name' => 'title_font_size',
			'value' => '',
			'description' => __( 'Enter your custom title font size . Example: 20px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Title Padding', DHVC_WOO ),
			'param_name' => 'title_padding',
			'value' => '',
			'description' => __( 'Enter your custom title padding . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Title Margin', DHVC_WOO ),
			'param_name' => 'title_margin',
			'value' => '',
			'description' => __( 'Enter your custom title margin . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'dhwc_layout_field_heading',
			'value' => 'Style Options',
			'param_name' => 'style_options'
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Show Excerpt', DHVC_WOO ),
			'param_name' => 'show_excerpt',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Excerpt Words', DHVC_WOO ),
			'param_name' => 'excerpt_length',
			'value' => '15',
			'description' => __( 'Excerpt max words', DHVC_WOO )
		),
		
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'dropdown',
			'std'=>'left',
			'heading' => __( 'Excerpt Align', DHVC_WOO ),
			'param_name' => 'excerpt_align',
			'value' => array (
				__( 'Left', DHVC_WOO ) => 'left',
				__( 'Center', DHVC_WOO ) => 'center',
				__( 'Right', DHVC_WOO ) => 'right'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Excerpt Color', DHVC_WOO ),
			'param_name' => 'excerpt_color',
			'value' => ''
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Excerpt Font Size', DHVC_WOO ),
			'param_name' => 'excerpt_font_size',
			'value' => '',
			'description' => __( 'Enter your custom excerpt font size . Example: 14px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Excerpt Padding', DHVC_WOO ),
			'param_name' => 'excerpt_padding',
			'value' => '',
			'description' => __( 'Enter your custom excerpt padding . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Excerpt Margin', DHVC_WOO ),
			'param_name' => 'excerpt_margin',
			'value' => '',
			'description' => __( 'Enter your custom excerpt margin . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'dhwc_layout_field_heading',
			'value' => 'Style Options',
			'param_name' => 'style_options'
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hide Price', DHVC_WOO ),
			'param_name' => 'hide_price',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Price Color', DHVC_WOO ),
			'param_name' => 'price_color',
			'value' => ''
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'colorpicker',
			'heading' => __( 'Non-discount Price Color', DHVC_WOO ),
			'param_name' => 'no_discount_price_color',
			'value' => ''
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Price Font Size', DHVC_WOO ),
			'param_name' => 'price_font_size',
			'value' => '',
			'description' => __( 'Enter your custom price font size . Example: 20px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Non-discount Price Font Size', DHVC_WOO ),
			'param_name' => 'no_discount_price_font_size',
			'value' => '',
			'description' => __( 'Enter your custom price font size . Example: 14px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Price Padding', DHVC_WOO ),
			'param_name' => 'price_padding',
			'value' => '',
			'description' => __( 'Enter your custom price padding . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Price Margin', DHVC_WOO ),
			'param_name' => 'price_margin',
			'value' => '',
			'description' => __( 'Enter your custom price margin . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'dhwc_layout_field_heading',
			'value' => 'Style Options',
			'param_name' => 'style_options'
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'checkbox',
			'heading' => __( 'Hide Add to cart', DHVC_WOO ),
			'param_name' => 'hide_addtocart',
			'value' => array (
				__( 'Yes, please', DHVC_WOO ) => 'yes'
			)
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Add To Cart Padding', DHVC_WOO ),
			'param_name' => 'addtocart_padding',
			'value' => '',
			'description' => __( 'Enter your custom add to cart padding . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Add To Cart Margin', DHVC_WOO ),
			'param_name' => 'addtocart_margin',
			'value' => '',
			'description' => __( 'Enter your custom add to cart margin . Example: 10px 10px 10px 10px.', DHVC_WOO )
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'type' => 'dhwc_layout_field_heading',
			'value' => 'Style Options',
			'param_name' => 'style_options'
		),
		array (
			'group' => __( 'Style settings', DHVC_WOO ),
			'save_always'=>true,
			'type' => 'dropdown',
			'heading' => __( 'Add Cart & Price Style', DHVC_WOO ),
			'param_name' => 'add_cart_price_style',
			'dependency' => array (
				'element' => 'display',
				'value' => array (
					'grid',
					'flex',
					'masonry',
					'carousel',
				)
			),
			'value' => array (
				__( '2 Columns', DHVC_WOO ) => '2column',
				__( '1 Colum Center', DHVC_WOO ) => '1column',
			)
		),
		array (
			'save_always'=>true,
			'type' => 'textfield',
			'heading' => __( 'Extra class name', DHVC_WOO ),
			'param_name' => 'el_class',
			'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', DHVC_WOO )
		)
	));
}