<?php
/**
 * The Template for displaying ordering options
 *
 * Override this template by copying it to yourtheme/dhvc-woocommerce/parts/orderby.php
 */

$default_orderby = wc_get_loop_prop( 'is_search' ) ? 'relevance' : apply_filters( 'woocommerce_default_catalog_orderby', get_option( 'woocommerce_default_catalog_orderby', '' ) );
$orderby         = isset( $_GET['orderby'] ) ? wc_clean( wp_unslash( $_GET['orderby'] ) ) : $default_orderby; // WPCS: sanitization ok, input var ok, CSRF ok.
$catalog_orderby_options = apply_filters( 'woocommerce_catalog_orderby', array(
	'menu_order' => __( 'Default sorting', DHVC_WOO ),
	'popularity' => __( 'Sort by popularity', DHVC_WOO ),
	'rating'     => __( 'Sort by average rating', DHVC_WOO ),
	'date'       => __( 'Sort by latest', DHVC_WOO ),
	'price'      => __( 'Sort by price: low to high', DHVC_WOO ),
	'price-desc' => __( 'Sort by price: high to low', DHVC_WOO ),
) );
if ( get_option( 'woocommerce_enable_review_rating' ) === 'no' )
	unset( $catalog_orderby_options['rating'] );
?>
<form class="dhvc-woo-ordering" method="get">
	<select name="orderby" class="orderby">
		<?php foreach ( $catalog_orderby_options as $id => $name ) : ?>
			<option value="<?php echo esc_attr( $id ); ?>" <?php selected( $orderby, $id ); ?>><?php echo esc_html( $name ); ?></option>
		<?php endforeach; ?>
	</select>
	<input type="hidden" name="paged" value="1" />
	<?php wc_query_string_form_fields( null, array( 'orderby', 'submit', 'paged', 'product-page' ) ); ?>
</form>