<?php
/**
 * The Template for displaying masonry style
 *
 * Override this template by copying it to yourtheme/dhvc-woocommerce/styles/masonry.php
 */
?>
<?php
if(empty($atts['category'])){
	echo __('Please select categories to use Masonry Layout',DHVC_WOO);
}else{
	
	wp_enqueue_script('isotope');
	
	ob_start();
	
	$masonry_order = isset($query_args['order']) ? $query_args['order'] : 'asc';
	$masonry_orderby = '';
	
	if($query_args['orderby'] === 'date ID'){
	    $masonry_orderby = 'date';
	}elseif ($query_args['orderby'] === 'modified'){
	    $masonry_orderby = 'modified';
	}
	
	echo '<div class="dhvc-woo-list-items dhvc-woo-masonry-list" data-orderby="'.$masonry_orderby.'" data-order="'.strtoupper($masonry_order).'" data-masonry-gutter="0">';
	
	if('5'===$atts['post_per_row'])
		$span_class =' dhvc-woo-span15';
	else
		$span_class = ' dhvc-woo-span'.(12/(int)$atts['post_per_row']);
	
	$tax_query = array();
	if(!empty($query_args['tax_query']))
		$tax_query = $query_args['tax_query'];
	
	$selected_cat_ids = explode(',',$atts['category']);
	$post_queried = array();
	
	$cat_fiters = array();
	foreach ($selected_cat_ids as $selected_cat_id){
		
		$selected_cat = get_term($selected_cat_id,'product_cat');
		$cat_fiters[$selected_cat_id] = '<li><a href="#" class="dhvc-woo-filter" data-option-value= ".dhvc-woo-cat-' . $selected_cat->term_id . '">' . $selected_cat->name . '</a></li>';
		
		$query_args['tax_query'] = $tax_query;
		$query_args['tax_query'][] = array(
			'taxonomy'  => 'product_cat',
			'field'    	=> 'id',
			'terms'    	=> array($selected_cat_id),
			'operator'  => 'IN'
		);
		$query_args['post__not_in'] = $post_queried;
		
		$new_query = new WP_Query( $query_args );
		
		while ($new_query->have_posts()): $new_query->the_post(); global $product;
			$product_cats = array ();
			$cats = get_the_terms ( $product->get_id(), 'product_cat' );
			if (! empty ( $cats )) {
				foreach ( $cats as $cat ) {
					$product_cats[] = 'dhvc-woo-cat-'.$cat->term_id;
				}
			}
			$post_queried[] = $product->get_id();
			?>
			<div data-date="<?php echo strtotime(get_the_date('Y-m-d H:i'))?>" data-modified="<?php echo strtotime(get_the_modified_date('Y-m-d H:i'))?>" class="dhvc-woo-masonry-item-selector <?php echo esc_attr($span_class).' '.implode( ' ', $product_cats )?>">
				<div class="dhvc-woo-item dhvc-woo-masonry-item">
					<?php 
					dhwc_layout_get_template('parts/image.php',array('atts'=>$atts));
					dhwc_layout_get_template('parts/info.php',array('atts'=>$atts));
					?>
				</div>
			</div>
			<?php
		endwhile;
		wp_reset_postdata();
	}
	
	echo '</div>';
	
	$output = ob_get_clean();
	if('yes'===$atts['show_masonry_filter']){
		?>
		<div class="dhvc-woo-filters">
			<ul data-option-key="filter">
				<li><a class="dhvc-woo-filter dhvc-woo-filter-all selected" href="#" data-option-value="*"><?php echo esc_html__( 'All', DHVC_WOO )?></a></li>
				<?php echo implode('', $cat_fiters);?>
			</ul>
		</div>
		<?php 
	}
	echo $output;
}




